SystemOrganization addCategory: #'Tank Game'!

Morph subclass: #Bullet
	instanceVariableNames: 'isAlive gravity xVel yVel timeAlive xMin xMax yMax strength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!Bullet commentStamp: '<historical>' prior: 0!
A Bullet is xxxxxxxxx.

Instance Variables
	bulletX:		<Object>
	bulletY:		<Object>
	gravity:		<Object>
	isAlive:		<Object>
	timeAlive:		<Object>
	xVel:		<Object>
	yVel:		<Object>

bulletX
	- xxxxx

bulletY
	- xxxxx

gravity
	- xxxxx

isAlive
	- xxxxx

timeAlive
	- xxxxx

xVel
	- xxxxx

yVel
	- xxxxx
!

!Bullet class methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/30/2014 23:27'!
height
	^20! !

!Bullet class methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/30/2014 23:27'!
width
	^20! !

!Bullet methodsFor: 'initialize' stamp: 'JonathanMark 7/29/2014 23:02'!
bulletX: x bulletY: y

	isAlive := true.
	self color: Color red.
	self bounds: (x@y extent: 20@20).

! !

!Bullet methodsFor: 'initialize' stamp: 'JonathanMark 8/2/2014 02:36'!
bulletX: x bulletY: y angle: ang speed:spd
	self bounds: (x@y extent: 20@20).
	
	strength := spd*0.04.
	xVel := (strength) * (ang degreesToRadians cos).
	yVel := (strength) * (ang degreesToRadians sin).

	isAlive := true.
	gravity := 0.005.
	timeAlive := 0.

	self changed.
! !

!Bullet methodsFor: 'initialize' stamp: 'JonathanMark 7/28/2014 23:15'!
bulletX: x bulletY: y angle: ang speed:spd xMin:xMn xMax:xMx yMax:yMx alive:aliveBool timeAlive: timeVal

	timeAlive := timeVal.
	isAlive := aliveBool.

	xMin := xMn.
	xMax := xMx.
	yMax := yMx.

	xVel := spd * (ang cos).
	yVel := spd * (ang sin).
	
	gravity := 0.005.
	strength := 10.
	timeAlive := 0.
	self bounds: (0@0 extent: 20@20).
	self changed.
! !

!Bullet methodsFor: 'modifying' stamp: 'GKB 7/16/2014 02:21'!
collision
	isAlive := false.
	self changed.! !

!Bullet methodsFor: 'as yet unclassified' stamp: 'JonathanMark 8/2/2014 02:19'!
drawOn: aCanvas

	| |
	
	(isAlive) ifTrue: [  
				aCanvas fillOval: bounds color: Color red.
				"self position: (
								(bulletX + ((self width )/2))@
								(bulletY + ((self height)/2)))."].! !

!Bullet methodsFor: 'modifying' stamp: 'GKB 7/16/2014 22:10'!
fire

	isAlive := true.

"	(isAlive) ifTrue: [ 
		bulletX := bulletX + (xVel*timeAlive).
		bulletY := bulletY + (yVel*timeAlive) + (0.5 * gravity* timeAlive * timeAlive).
		self position: (bulletX@bulletY).		
		timeAlive := timeAlive + (self stepTime).
]."
	self changed.! !

!Bullet methodsFor: 'modifying' stamp: 'JonathanMark 7/25/2014 22:42'!
getStrength
 ^strength.! !

!Bullet methodsFor: 'modifying' stamp: 'GKB 7/16/2014 22:13'!
isAlive
	^isAlive.! !

!Bullet methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/29/2014 23:29'!
kill
	isAlive := false.
	self changed.! !

!Bullet methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/28/2014 22:19'!
serialize
	"serialize to send to server"
	|alive|
	isAlive = true ifTrue: [ 
		alive := 1.
	 ].
	isAlive = false ifTrue: [ 
		alive := 0.
	 ].
	^(xVel asString , ':', yVel asString, ':', strength asString).! !

!Bullet methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/29/2014 00:36'!
serializeFire
	"serialize to send to server"
	^(xVel asString , ':', yVel asString, ':', strength asString).! !

!Bullet methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/29/2014 23:42'!
serializePos
	"serialize to send to server"
	(isAlive) ifTrue: [^(';', self position x asString , ':', self position y asString) ]
	ifFalse: [ ^'' ].! !

!Bullet methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/30/2014 23:27'!
serializePosFor:aPlayer
	"serialize to send to server"
	| xPos |
	xPos := self position x.
	(aPlayer = 2) ifTrue:[ xPos := 1200 - xPos - Bullet width ].
	(isAlive) ifTrue: [^(';', xPos asString , ':', self position y asString) ]
	ifFalse: [ ^'' ].! !

!Bullet methodsFor: 'as yet unclassified' stamp: 'JonathanMark 8/2/2014 02:45'!
stepManual
(self isAlive) ifTrue: [ 
"	self position setX: (self position x + (xVel) ) asInteger setY: (self position y - (yVel) + (0.0005 * timeAlive * timeAlive)) asInteger."
	self bulletX: (self position x + (xVel) ) asInteger bulletY:(self position y - (yVel) + (0.05 * timeAlive * timeAlive)) asInteger.
	timeAlive := timeAlive + 1.
	Transcript show: 'updated';cr.
	(self position x < 1) ifTrue: [ self kill ].
	( (self position x + ((Tank width /2) asInteger)) > 1200) ifTrue: [ self kill ].
	(self position y > 720) ifTrue: [ self kill ].
]! !

!Bullet methodsFor: 'initialize' stamp: 'JonathanMark 7/29/2014 23:18'!
xMin:xMn xMax:xMx yMax:yMx

	xMin := xMn.
	xMax := xMx.
	yMax := yMx.

	strength := 0.

	xVel := 0.
	yVel := 0.
	
	isAlive := false.
	gravity := 0.005.
	timeAlive := 0.
	
	self changed.
! !

Morph subclass: #GameBoard
	instanceVariableNames: 'keyBindings actionList hori vert spinR tank power angle playerOne playerTwo client level PlayerOneHealthHUD PlayerTwoHealthHUD PlayerOneAngleHUD PlayerOnePowerHUD font rebindHUD quitHUD curState keyDebug fireString playerList EndOfGameHUD'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!GameBoard commentStamp: 'GKB 7/13/2014 17:50' prior: 0!
I created this as a placeholder for the player input handler. Open the transcript to view the function flow. The temporary gameboard morph is in the top left, you can hover over that and start accpeting keyboard inputs. You can also click in the morph to hold keyboard focus when the mouse leaves. You can also call rebindKeys to rebind player functions and keys.
!

!GameBoard methodsFor: 'playerActions' stamp: 'GKB 7/17/2014 18:03'!
decreasePower

	| playerOnePower |
	
	playerOnePower := 0.

	playerOnePower := playerOne getTank getPower.

	(playerOnePower <= 0)
		ifTrue: [ playerOne getTank setPower: 0. ]
		ifFalse: [ playerOne getTank setPower: (playerOnePower - 1). ].
		
Transcript show: ('Decrease Power to ',((playerOne getTank getPower) asString)) .
Transcript cr.! !

!GameBoard methodsFor: 'playerActions' stamp: 'JonathanMark 7/19/2014 12:43'!
did: morph1 collideWith: morph2
"basic collision detection using rectangels"
 
	| a b c d e f g h |

	a := (morph1 position x).
	b := (morph1 position y).
	c := ((morph1 position x) + (morph1 width)).
	d := ((morph1 position y) + (morph1 height)).
	
	e := (morph2 position x).
	f := (morph2 position y).
	g := ((morph2 position x) + (morph2 width)).
	h := ((morph2 position y) + (morph2 height)).
	
	( (a < g) & (c > e) & (b < h) & (d > f))
		ifTrue: [
				 "Transcript show: 'collision!!'."
				 "Transcript cr."
				 ^true. ]
		ifFalse:[ ^false].
		
	! !

!GameBoard methodsFor: 'Drawing' stamp: 'JonathanMark 7/18/2014 18:22'!
"protocol: drawing"
drawOn: aCanvas
	"comment stating purpose of message"

	super drawOn: aCanvas.
	
	1 to: level size do: [  :x |
		aCanvas line: x@(self height) to: x@(level at: x) width: 1 color: Color darkGray.
	].! !

!GameBoard methodsFor: 'playerActions' stamp: 'JonathanMark 7/29/2014 21:48'!
fire
| fireAngle fireSpeed |
Transcript show: 'Fire gun'.
Transcript cr.

fireAngle := playerOne getTank getAngle - playerOne getShell rotationDegrees.
fireSpeed := playerOne getTank getPower.
fireString := (';', fireAngle asString, ',', fireSpeed asString).
"
(playerOne getBullet isAlive) 
	ifFalse: [ 
		
 		(playerOne getBullet) bulletX: ((playerOne  getX)+((playerOne getTank width)/2))  
							    bulletY: ((playerOne  getY)) 
							    angle: (-1)*(fireAngle degreesToRadians) 
							    speed: (0.3*(playerOne getTank getPower)/100).
		self addMorph: (playerOne getBullet).] 
	ifTrue: [ 
		Transcript show: 'No Ammo!!'.
		Transcript cr.]
"! !

!GameBoard methodsFor: 'run' stamp: 'JonathanMark 7/28/2014 22:57'!
getPlayer1Bullet
	"return a string with the information about player 1"
	^self getPlayerOne getBullet serializePos.! !

!GameBoard methodsFor: 'run' stamp: 'JonathanMark 7/28/2014 22:56'!
getPlayer1FireString
	"return a string with the information about player 1"
	^self getPlayerOne getBullet serializeFire.! !

!GameBoard methodsFor: 'run' stamp: 'JonathanMark 7/29/2014 18:03'!
getPlayer1Information
	"return a string with the information about player 1"
	"Return the x position of the tank"
	| infoString |
	infoString := (((self getPlayerOne getX) asInteger asString), ':', self getPlayerOne getHealth asString, ':', self getPlayerOne getTank getAngle asString).
	"infoString := infoString, ','."
	^infoString.! !

!GameBoard methodsFor: 'accessing' stamp: 'CaseyPiper 7/25/2014 01:10'!
getPlayerOne
	^playerOne! !

!GameBoard methodsFor: 'accessing' stamp: 'CaseyPiper 7/25/2014 10:37'!
getPlayerTwo
	^playerTwo! !

!GameBoard methodsFor: 'run' stamp: 'JonathanMark 8/2/2014 02:03'!
handleBulletUpdate: anUpdate for: playerNum
	| xPos yPos bAngle bSpeed tokens |

	tokens := (anUpdate subStrings: ':').
	(tokens size < 4)
	ifFalse: [ 
		xPos := (tokens at:1) asInteger .
		yPos := (tokens at:2) asInteger.
		bAngle := (tokens at:3) asInteger.
		bSpeed := (tokens at:4) asInteger.
		(playerList at: playerNum) getBullet bulletX: xPos bulletY: yPos angle: bAngle speed: bSpeed.
		self changed.
	]
! !

!GameBoard methodsFor: 'playerInput' stamp: 'JonathanMark 7/27/2014 22:32'!
handleKeystroke: anEvent
| keyValue |

keyValue := keyBindings at: (anEvent keyValue)  ifAbsent: nil.
(keyDebug) ifTrue:[
	Transcript show: 'Keyboard Input: ', (anEvent keyCharacter) asString, '. Ascii Value: ', (anEvent keyValue) asString.
	Transcript cr.
].

keyValue = #moveLeft
	ifTrue: [self moveLeft].
keyValue = #moveRight
	ifTrue: [self moveRight].
keyValue =#rotateCW
	ifTrue: [self rotateCW].
keyValue = #rotateCCW
	ifTrue: [self rotateCCW].
keyValue =#increasePower
	ifTrue: [self increasePower].
keyValue = #decreasePower
	ifTrue: [self decreasePower].
keyValue = #fire
	ifTrue: [self fire].
keyValue = nil
	ifTrue: [Transcript show: 'No action bound to this key.'.
			Transcript cr.].! !

!GameBoard methodsFor: 'run' stamp: 'JonathanMark 8/2/2014 01:15'!
handlePlayerUpdate: anUpdate
	| playerTokens |

	playerTokens := anUpdate subStrings: ':'.
	playerTokens size < 4 ifTrue: [ ^false ].
	self player2Update: (1200 - ((playerTokens at: 1) asInteger)).
	playerTwo setHealth: ((playerTokens at: 2) asInteger).
	playerTwo getTank setAngle: (((playerTokens at: 3) asInteger) negated + 180).
	playerOne setHealth: ((playerTokens at: 4) asInteger).
	^true.! !

!GameBoard methodsFor: 'run' stamp: 'JonathanMark 8/2/2014 02:11'!
handleServerUpdate: anUpdate
	| latestUpdate tokens playerTokens bulletToken1 bulletToken2 |

	latestUpdate := (anUpdate subStrings: '|') last.
	tokens := (latestUpdate subStrings: ';').
	
	(tokens size > 0) ifTrue: [
		playerTokens := tokens at:1.
		(self handlePlayerUpdate: playerTokens) ifFalse: [^nil.] .
	].
	(tokens size > 1) ifTrue: [
		bulletToken1 := tokens at:2.
		self handleBulletUpdate: bulletToken1 for: 1.
	].
	(tokens size > 2) ifTrue: [
		bulletToken2 := tokens at:3.
		self handleBulletUpdate: bulletToken2 for: 2.
	].
! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/13/2014 17:31'!
handlesMouseDown: anEvent

	^true! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/13/2014 13:11'!
handlesMouseOver: anEvent

	^true! !

!GameBoard methodsFor: 'playerActions' stamp: 'GKB 7/17/2014 18:04'!
increasePower

"(power >= 100)
		ifTrue: [ power := 100. ]
		ifFalse: [ power := power + 1. ].
		
Transcript show: ('Increase Power to ',(power asString)) .
Transcript cr."

| playerOnePower |
	
	playerOnePower := 0.

	playerOnePower := playerOne getTank getPower.

	(playerOnePower >= 100)
		ifTrue: [ playerOne getTank setPower: 100. ]
		ifFalse: [ playerOne getTank setPower: (playerOnePower + 1). ].
		
Transcript show: ('Increase Power to ',((playerOne getTank getPower) asString)) .
Transcript cr.! !

!GameBoard methodsFor: 'initialize' stamp: 'JonathanMark 8/2/2014 01:03'!
initialize
	super initialize.
	
	self setBindings.
		
	self height: 720.
	self width: 1200.
	self color: Color lightGray.
	hori := 3.
	vert := 3.
	spinR := 1.
	
	keyDebug := false.
	
	curState := nil.
	fireString := '' .
	
	client := Client new.
			"uncomment to start network"
	client start: 12346.
	client setPlayerX: 800.
	client setGame: self.
	self processInitString: (client getInitString).
	
	"Old Structure where the gamboard has tanka nd bullet objects"
	"A few methods need to be slightly modified to reimplement this"
	"tank := TankMorph new.
	tank position:(100@600).
	self addMorph:  tank."
	
	"self openInWindowLabeled:'Tank Game'."
	
	"bullet := (Bullet new xMin: (self position x) xMax: ((self position x) + 1200) yMax: ((self position y) + 720)).
	power := 50.
	angle := 45."
	
	"New structure where a player object has a tank and a bullet"
	playerOne := Player new 
					xMin: (self position x) 
					xMax: ((self position x) + 1200) 
					yMax: ((self position y) + 720)  
					tankX: 100 
					tankY: 600.
	self addMorph: (playerOne getTank). 
	self addMorph: (playerOne getBullet).
	playerOne setShell.
	self player1Move: 0.

	playerTwo := Player new 
					xMin: (self position x) 
					xMax: ((self position x) + 1200) 
					yMax: ((self position y) + 720)  
					tankX: 100 
					tankY: 600.
	self addMorph: (playerTwo getTank). 
	self addMorph: (playerTwo getBullet). 
	playerTwo setShell.
	self player2Update: (self width - 100).
	
	playerList := Array new: 2.
	playerList at:1 put: playerOne.
	playerList at:2 put: playerTwo.

font := (TextFontReference toFont: (LogicalFont familyName: 'Cochin' pointSize: 99)).
 PlayerOneHealthHUD :=  HUD new 
        setFont: font 
        setString: 'Player One Health: ' 
        setValue:  (playerOne getHealth asString)
        setX:  50
        setY: 25.
 PlayerTwoHealthHUD  := HUD new 
        setFont: font 
        setString: 'Player Two Health: ' 
        setValue:  (playerTwo getHealth asString)
        setX:  800
        setY: 25.
 PlayerOneAngleHUD  := HUD new 
        setFont: font 
        setString: 'Player One Angle: ' 
        setValue:  (playerOne getTank getAngle asString)
        setX:  50
        setY: 600.
 PlayerOnePowerHUD  := HUD new 
        setFont: font 
        setString: 'Player One Power: ' 
        setValue:  (playerOne getTank getPower asString)
        setX:  500
        setY: 600.
 EndOfGameHUD  := HUD new 
        setFont: font 
        setString: '' 
        setValue:  ''
        setX:  300
        setY: 300.


 self addMorph: PlayerOneHealthHUD.
 self addMorph: PlayerTwoHealthHUD.
 self addMorph: PlayerOneAngleHUD.
 self addMorph: PlayerOnePowerHUD.
 self addMorph: EndOfGameHUD.
 
 rebindHUD  := HUDbutton new 
        setLabel: 'Rebind Keys' 
        setHeight: 50
        setWidth:  200
        setX:  950
        setY: 500
        gameBoard: [self rebindKeys ].
 
 quitHUD  := HUDbutton new 
        setLabel: 'Quit Game' 
        setHeight: 50
        setWidth:  200
        setX:  950
        setY: 600
        gameBoard: [self delete].
 self addMorph: quitHUD. 
 self addMorph: rebindHUD.
 
 self openInWorld.
	! !

!GameBoard methodsFor: 'playerInput' stamp: 'JonathanMark 7/14/2014 20:28'!
mouseDown: anEvent

"game holds keyboard focus of the user clicks"
 anEvent hand newKeyboardFocus: self.



anEvent redButtonPressed
	ifTrue: [
			Transcript show: 'Red Mouse Button Click'.
			Transcript cr].
anEvent yellowButtonPressed
	ifTrue: [Transcript show: 'Yellow Mouse Button Click'.
			Transcript cr].
self changed.
! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/13/2014 15:28'!
mouseEnter: anEvent
"anEvent hand newKeyboardFocus: self"
"mouseIn := true."! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/13/2014 15:28'!
mouseLeave: anEvent
"anEvent hand newKeyboardFocus: nil"
"mouseIn := false."! !

!GameBoard methodsFor: 'playerActions' stamp: 'JonathanMark 7/27/2014 22:31'!
"protocol: playerActions"
moveLeft

| xStep |

	xStep := -10.

self player1Move: xStep.

"client updateData: playerOne."! !

!GameBoard methodsFor: 'playerActions' stamp: 'JonathanMark 7/27/2014 22:31'!
"protocol: playerActions"
moveRight

	| xStep |

	xStep := 10.

self player1Move: xStep.

"client updateData: playerOne."! !

!GameBoard methodsFor: 'playerActions' stamp: 'JonathanMark 7/25/2014 19:41'!
player1Move: aNumber
	"comment stating purpose of message"
	| xCord yCord aShell slope ang rad |
	
	aShell := playerOne getShell.
	
	aShell rotationDegrees: 0.
	xCord := playerOne getX + aNumber.
	
	(xCord <= 0) ifTrue: [ ^false ].
	((xCord  + aShell width)> (level size)) ifTrue: [ ^false ].
	
	slope := level slopeFrom: xCord to: xCord + aShell width.
	rad := slope arcTan.
	ang := rad radiansToDegrees.
	yCord := ((level at: xCord) - aShell height + ((rad sin * aShell width / 2) ceiling)).

	aShell position: xCord@yCord.
	aShell rotationDegrees: ang.
	
	self changed.! !

!GameBoard methodsFor: 'playerActions' stamp: 'JonathanMark 7/25/2014 19:43'!
player2Update: xCord
	"comment stating purpose of message"
	| yCord aShell slope ang rad |

	aShell := playerTwo getShell.
	
	aShell rotationDegrees: 0.
	
	xCord := xCord - aShell width.
	
	(xCord <= 0) ifTrue: [ ^false ].
	((xCord  + aShell width)> (level size)) ifTrue: [ ^false ].
	
	slope := level slopeFrom: xCord to: xCord + aShell width.
	rad := slope arcTan.
	ang := rad radiansToDegrees.
	yCord := (((level at: (xCord + aShell width)) - aShell height) ceiling) - ((rad sin * aShell width / 2)). 
	"- ((rad sin * aShell width / 2) ceiling))"

	aShell position: xCord@yCord.
	aShell rotationDegrees: ang.
	
	self changed.! !

!GameBoard methodsFor: 'initialize' stamp: 'JonathanMark 7/28/2014 21:07'!
processInitString: initString
	"comment stating purpose of message"
	| tokenizedString levelVar1 levelVar2 levelVar3 dirVar |
	
	(initString == nil)
		ifTrue:[
			Transcript show: ('initString is nil').
			levelVar1 := (1 to: 10) atRandom.
			levelVar2 := (20 to: 100) atRandom.
			levelVar3 := (1 to: 100) atRandom.
			dirVar := 1.
		]
		ifFalse: [
			Transcript show: ('initString is: ', initString).
			tokenizedString := initString subStrings: ','.
			levelVar1 := ((tokenizedString at: 1) asInteger).
			levelVar2 := ((tokenizedString at: 2) asInteger).
			levelVar3 := ((tokenizedString at: 3) asInteger).
			dirVar :=  ((tokenizedString at: 4) asInteger).
		].
	level := Level new: self width.
	level := level var1: levelVar1 var2: levelVar2 var3: levelVar3 dir: dirVar.
	! !

!GameBoard methodsFor: 'playerInput' stamp: 'GKB 7/14/2014 18:53'!
rebindKeys

	| keyToChange changeToThis |
	
	keyToChange := 0.
	changeToThis := 0.
						
	keyToChange := UIManager default 
						chooseFrom: actionList 
						lines: #(2 4 6) 
						message: 'Which action would you like to rebind?'
						title: 'Rebind keys'.
	
						
	(keyToChange = 0)
		ifFalse: [ 
				
				(keyBindings keysAndValuesDo: 
				[ :key :val | val = (actionList at: keyToChange)  
					ifTrue:[changeToThis := UIManager default 
											request: 'Bind ', (actionList at: keyToChange),' to what key? It only takes the first charater' 
											initialAnswer: key asCharacter. 
							(changeToThis isNil) ifFalse: [ keyBindings removeKey: key]. 
						    ]  
				]).

				(changeToThis isNil) 
				ifFalse: [ 
					keyBindings at: (changeToThis first asciiValue) put:(actionList at: keyToChange).
						]
				].
	! !

!GameBoard methodsFor: 'playerActions' stamp: 'JonathanMark 7/18/2014 18:22'!
rotateCCW

"(angle+1 >= 360)
		ifTrue: [ angle := angle + 1 - 360. ]
		ifFalse: [ angle := angle + 1. ].
		
		tank setAngle: angle.
		self changed.
Transcript show: ('Rotate Tank Counterclockwise to ',(angle asString)) .
Transcript cr."

((playerOne getTank getAngle)+5 >= 360)
		ifTrue: [ playerOne getTank setAngle:((playerOne getTank getAngle) + 5 - 360). ]
		ifFalse: [ playerOne getTank setAngle:((playerOne getTank getAngle) + 5). ].

	"tank setAngle: angle."
	self changed.
Transcript show: ('Rotate Tank Counterclockwise to ',((playerOne getTank getAngle) asString)) .
Transcript cr.
! !

!GameBoard methodsFor: 'playerActions' stamp: 'JonathanMark 7/18/2014 18:22'!
rotateCW

((playerOne getTank getAngle) <= 0)
		ifTrue: [ playerOne getTank setAngle:((playerOne getTank getAngle) - 5 + 360). ]
		ifFalse: [ playerOne getTank setAngle:((playerOne getTank getAngle) - 5). ].

	"tank setAngle: angle."
	self changed.
Transcript show: ('Rotate Tank Clockwise to ',((playerOne getTank getAngle) asString)) .
Transcript cr.
! !

!GameBoard methodsFor: 'initialize' stamp: 'JonathanMark 7/18/2014 18:23'!
"protocol: initialize"
setBindings
	"comment stating purpose of message"

	keyBindings := Dictionary new.
		
	keyBindings at:($a asciiValue)   put: #moveLeft. 
	keyBindings at:($d asciiValue) put: #moveRight. 
	keyBindings at:($j asciiValue)   put: #rotateCCW. 
	keyBindings at:($l asciiValue)   put: #rotateCW. 
	keyBindings at:($i asciiValue)   put: #increasePower. 
	keyBindings at:($k asciiValue)   put: #decreasePower. 	
	keyBindings at:32   put: #fire. 			"32 = 	spaceBar"
	
	actionList := Set new.
	actionList := #(	'moveLeft' 'moveRight' 'rotateCW' 'rotateCCW' 'increasePower' 'decreasePower' 'fire').! !

!GameBoard methodsFor: 'run' stamp: 'JonathanMark 8/2/2014 01:55'!
step
	| newState serverUpdate|
	
	newState := ('|', self getPlayer1Information, fireString).
	
	self updateBullets.
	
	(newState = curState) ifFalse:[
		client send: newState.
		fireString := ''.
		curState := ('|', self getPlayer1Information, fireString).
	].
	
	serverUpdate := client receive.

	(serverUpdate = nil) ifFalse:[
		self handleServerUpdate: serverUpdate.
	].
	
	PlayerOneHealthHUD setValue:  (playerOne getHealth asString).
	PlayerTwoHealthHUD setValue:  (playerTwo getHealth asString).
	PlayerOneAngleHUD  setValue:  (playerOne getTank getAngle  asString).
	PlayerOnePowerHUD setValue:  (playerOne getTank getPower asString).
	
	(playerOne isAlive = false)
	ifTrue: [ EndOfGameHUD setValue: 'You Lose!!' ].
	(playerTwo isAlive = false)
	ifTrue: [ EndOfGameHUD setValue: 'You Win!!' ].

	"
	(playerOne getBullet isAlive)
	ifTrue: [ 
			(self did: (playerOne getBullet) collideWith: (playerTwo getShell)) 
					ifTrue: [ playerTwo setHealth: ((playerTwo getHealth) - (playerOne getBullet getStrength)).
							Transcript show: ('Player 1 bullet hit Player 2. Player 2 Health: ',((playerTwo getHealth) asString)) . 
							 Transcript cr. 
							(playerOne getBullet collision ).]
			].
	(playerTwo getBullet isAlive)
	ifTrue: [ 
			(self did: (playerTwo getBullet) collideWith: (playerOne getShell)) 
					ifTrue: [ playerOne setHealth: ((playerOne getHealth) - (playerTwo getBullet getStrength)).
							Transcript show: ('Player 2 bullet hit Player 1. Player 2 Health: ',((playerOne getHealth) asString)) . 
							 Transcript cr. 
							(playerTwo getBullet collision ).]
			].
		"! !

!GameBoard methodsFor: 'run' stamp: 'JonathanMark 7/27/2014 20:49'!
stepTime
^33! !

!GameBoard methodsFor: 'run' stamp: 'JonathanMark 8/2/2014 02:26'!
updateBullets
	|  bullet |
	
	((playerOne getBullet) isAlive) ifTrue: [ 
			bullet := (playerOne getBullet).
			(playerOne getBullet) stepManual.

			((playerOne getBullet) isAlive) ifTrue: [ 
				"( (bullet position y + 20) > (level at: ((bullet position x) + (Bullet width / 2) asInteger )) ) ifTrue: [ (playerOne getBullet) kill ]."
			].

	].
	((playerTwo getBullet) isAlive) ifTrue: [ 
			(playerTwo getBullet) stepManual.
			bullet := (playerTwo getBullet).
			((playerTwo getBullet) isAlive) ifTrue: [ 
				"((bullet position y + 20) > (level at: ((bullet position x) + (Bullet width /2) asInteger )) ) ifTrue: [ (playerTwo getBullet) kill ]."
			].
			 
	].
self changed.
! !

Morph subclass: #Server
	instanceVariableNames: 'levelVar1 levelVar2 levelVar3 client1Data client2Data socket P1Client socket2 P2Client socket1 quitServer bulletList level playerState player1State player2State bullet1State bullet2State playerHealthList playerXList bulletString'
	classVariableNames: 'P1Update P2Update'
	poolDictionaries: ''
	category: 'Tank Game'!

!Server commentStamp: '<historical>' prior: 0!
A Server is the server for the game that sends locations of tanks back to the otehr client.
!

!Server methodsFor: 'initialize' stamp: 'JonathanMark 7/27/2014 23:59'!
addQuit

 quitServer  := HUDbutton new 
        setLabel: 'Quit Server' 
        setHeight: 50
        setWidth:  200
        setX:  0
        setY: 10
        gameBoard: [
		P1Client closeAndDestroy.
		socket1 closeAndDestroy.
		P2Client closeAndDestroy.
		socket2 closeAndDestroy.
		Transcript show: 'server for player 1 destroyed'; cr.
		self delete.
		].

 self addMorph: quitServer. ! !

!Server methodsFor: 'run' stamp: 'JonathanMark 7/29/2014 23:43'!
bulletIsAlive
	((bulletList at: 1) isAlive) ifTrue: [ ^true ].
	((bulletList at: 2) isAlive) ifTrue: [ ^true ].
	^false.! !

!Server methodsFor: 'run' stamp: 'JonathanMark 7/29/2014 23:43'!
bulletStateChange
	((bulletList at: 1) isAlive) ifTrue: [ 
		(bullet1State) ifFalse: [ bullet1State := true. ^true ].
	]
	ifFalse:[
		(bullet1State) ifTrue: [ bullet1State := false. ^true ].
	].
	((bulletList at: 2) isAlive) ifTrue: [ 
		(bullet2State) ifFalse: [ bullet2State := true. ^true ].
	]
	ifFalse:[
		(bullet2State) ifTrue: [ bullet2State := false. ^true ].
	].
	^false.! !

!Server methodsFor: 'run' stamp: 'JonathanMark 7/29/2014 23:43'!
bulletStateChangeOrAlive
	| out |
	out := false.
	((bulletList at: 1) isAlive) ifTrue: [ out := true. bullet1State :=true. ]
	ifFalse:[
		(bullet1State) ifTrue: [out := true.].
		 bullet1State := false. 
	].

	((bulletList at: 2) isAlive) ifTrue: [ out := true. bullet2State :=true. ]
	ifFalse:[
		(bullet2State) ifTrue: [ out := true ].
		bullet2State := false. 
	].

	^out.! !

!Server methodsFor: 'run' stamp: 'JonathanMark 7/30/2014 23:51'!
checkCollision: aTankX bullet: aBulletNum
"From left side level to right side level check if a bullet is in contact with tank height above the level"
| aBullet |
aBullet := bulletList at: aBulletNum.

(aBullet isAlive) ifTrue:[
"	Transcript show: (aBullet position x > (aTankX - Bullet width)) asString , ' ',(aBullet position x < (aTankX + Tank width)) asString, ' ', aBullet position y asString; cr.
	Transcript show: aBullet position x asString, ' ', (aTankX) asString, ' ', Bullet width asString; cr."
	((aBullet position x > (aTankX - Bullet width)) and: (aBullet position x < (aTankX + Tank width))) ifTrue:[
		aTankX to: (aTankX + Tank width) do: [  :x |
			| aTankY |
			aTankY := level at: x.
			"Transcript show: aBullet position y asString, ' ', (aTankY) asString, ' ', Bullet width asString; cr."
			(((aBullet position y + Bullet height) > (aTankY  - Bullet height)) and: (aBullet position y < (aTankY + Tank height))) 
				ifTrue:[ 
					"Transcript show: aTankX asString, ' ', aBullet position x asString, ' ', aBullet position y asString; cr."
					"Transcript show: 'Hit!!'; cr."
					(bulletList at: aBulletNum) kill.
					^true
				].
		].
	].
].

^false.! !

!Server methodsFor: 'run' stamp: 'JonathanMark 7/30/2014 23:28'!
getPlayerFromUpdate: anUpdate
	|  latestUpdate playerTokens tankTokens |
	
	latestUpdate := (anUpdate subStrings: '|') last.
	
	playerTokens := (latestUpdate subStrings: ';') at:1.
	
	tankTokens := playerTokens subStrings: ':'.
	
	tankTokens at: 2 put: playerHealthList.

	^playerTokens
! !

!Server methodsFor: 'run' stamp: 'JonathanMark 7/30/2014 23:37'!
getPlayerFromUpdate: anUpdate from: aPlayer
	|  latestUpdate playerTokens tankTokens otherPlayerHealth |
	
	latestUpdate := (anUpdate subStrings: '|') last.
	
	playerTokens := (latestUpdate subStrings: ';') at:1.
	
	tankTokens := playerTokens subStrings: ':'.
	
	tankTokens at: 2 put: (playerHealthList at: aPlayer) asString.
	
	(aPlayer = 1) ifTrue:[otherPlayerHealth := playerHealthList at: 2]
				  ifFalse:[otherPlayerHealth := playerHealthList at: 1].
	

	^((tankTokens at:1), ':', (tankTokens at:2), ':', (tankTokens at: 3), ':', otherPlayerHealth asString).
! !

!Server methodsFor: 'run' stamp: 'JonathanMark 8/2/2014 01:51'!
handleBulletUpdate: anUpdate from: playerNum
	| bulletTokens angle speed  tankX tankY |
	
	bulletTokens := anUpdate subStrings: ','.
	
	angle := (bulletTokens at: 1) asInteger.
	(playerNum = 2) ifTrue:[ angle := angle negated + 180 ].
	
	speed := (bulletTokens at:2) asInteger.
	
	tankX := playerXList at: playerNum.
	
	(playerNum = 1) ifTrue:[tankX := tankX + (Tank width / 2) asInteger.]
					 ifFalse:[tankX := tankX - (Tank width / 2) asInteger.].
	
	tankY := ((level at: tankX) - (Tank height)) asInteger.
	
	(playerNum = 1) ifTrue: [bulletString at: playerNum put: (';', tankX asString, ':', tankY asString, ':', angle asString, ':', speed asString).]
					 ifFalse: [ bulletString at: playerNum put: (';', (1200 - tankX) asString, ':', tankY asString, ':', angle asString, ':', speed asString). ].
		
	

	(bulletList at: playerNum) bulletX: tankX bulletY: tankY angle: angle speed: speed.! !

!Server methodsFor: 'run' stamp: 'JonathanMark 7/30/2014 23:29'!
handleTankUpdate: anUpdate from: playerNum
	| tankX tankTokens |
	
	tankTokens := anUpdate subStrings: ':'.
	tankX := (tankTokens at:1) asInteger.
	
	(playerNum = 2) ifTrue: [ tankX := (1200 - tankX)].
	
	playerXList at: playerNum put: (tankX).
	
	! !

!Server methodsFor: 'run' stamp: 'JonathanMark 8/2/2014 01:47'!
handleUpdate: anUpdate from: playerNum
	|  latestUpdate tokens playerTokens bulletTokens |
	
	latestUpdate := (anUpdate subStrings: '|') last.
	
	tokens := (latestUpdate subStrings: ';').
	
	playerTokens := tokens at:1.
	self handleTankUpdate: playerTokens from: playerNum.
	
	(tokens size > 1) ifTrue: [
		bulletTokens := tokens at:2.
		self handleBulletUpdate: bulletTokens from: playerNum.
	]
	ifFalse: [bulletString at: playerNum put: ''].

! !

!Server methodsFor: 'initialize' stamp: 'JonathanMark 8/2/2014 01:41'!
initialize
super initialize.
self width: 200.

Transcript show: 'initializing sockets ... '.
Transcript show: 'ok'; cr.
P1Update := nil.
P2Update := nil.
socket1 := nil.
socket2 := nil.
client1Data := nil.
client2Data := nil.

levelVar1 := (1 to: 10) atRandom.
levelVar2 := (20 to: 100) atRandom.
levelVar3 := (1 to: 100) atRandom.

level := Level new: 1200.
level := level var1: levelVar1 var2: levelVar2 var3: levelVar3 dir: 1.

playerXList := Array new: 2.
playerHealthList := Array new: 2.
bulletList := Array new: 2.
bulletString := Array new: 2.
bullet1State := true.
bullet2State := true.

[self startPlayer1Socket.] forkAt: Processor userBackgroundPriority.
[self startPlayer2Socket.] forkAt: Processor userBackgroundPriority.

(Delay forSeconds: 10) wait.

self addQuit.

self openInWorld.
! !

!Server methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/25/2014 19:16'!
initializeGameForPlayer: aPlayer usingSocket: aSocket
	"data should be filled with whatever is needed for the client to initialize."

	aSocket sendData:   levelVar1 asString, ',', levelVar2 asString, ',', levelVar3 asString, ',', aPlayer asString.! !

!Server methodsFor: 'initialize' stamp: 'JonathanMark 8/2/2014 00:10'!
startPlayer1Socket
|   |
socket1 := Socket newTCP.
socket1 listenOn: 12345 backlogSize: 5 interface: (NetNameResolver addressForName: '25.61.19.54').

	P1Client := socket1 waitForAcceptFor: 10.
	Transcript show: 'connected or finished waiting'; cr.
	
	P1Client = nil ifFalse: [ 
		"connection established"
		Transcript show: 'connection established'; cr.
		P1Client isConnected ifTrue: [ 
			self initializeGameForPlayer: 1 usingSocket: P1Client.
		].
	].

playerXList at:1 put: 0.
playerHealthList at:1 put: 100.
bulletList at: 1 put: (Bullet new).
(bulletList at: 1) width: 20.
(bulletList at: 1) kill.! !

!Server methodsFor: 'initialize' stamp: 'JonathanMark 8/2/2014 00:10'!
startPlayer2Socket
|  |
socket2 := Socket newTCP.
socket2 listenOn: 12346 backlogSize: 5 interface: (NetNameResolver addressForName: '25.61.19.54').

	P2Client := socket2 waitForAcceptFor: 10.
	P2Client = nil ifFalse: [ 
		"connection established"
		P2Client isConnected ifTrue: [ 
			self initializeGameForPlayer: 2 usingSocket: P2Client.
		].
	].

playerXList at:2 put: 0.
playerHealthList at:2 put: 100.
bulletList at: 2 put: (Bullet new).
(bulletList at: 2) width: 20.
(bulletList at: 2) kill.! !

!Server methodsFor: 'run' stamp: 'JonathanMark 8/2/2014 01:49'!
step
| P1Buf P2Buf outString forceRun |

	P1Buf := String new: 1000.
	P2Buf := String new: 1000.
	
	self updateBullets.
	
	"forceRun := self bulletStateChangeOrAlive."

	( P1Client dataAvailable ) ifTrue:
	[ 
		P1Client receiveDataInto: P1Buf.
		(P2Client = nil )
		ifFalse: [
			self handleUpdate: P1Buf from: 1.
			player1State := P1Buf.
			outString := ( '|', (self getPlayerFromUpdate: player1State from: 1),bulletString at: 1,bulletString at: 2 ).
			P2Client sendData: outString.
			Transcript show: outString;cr.
		]
		ifTrue:[
			self color: Color red.
		].
 	].
	"ifFalse:[
		
		(forceRun) ifTrue:[
			outString := ( '|', (self getPlayerFromUpdate: player1State from: 1),((bulletList at: 1) serializePosFor: 2),((bulletList at:2) serializePosFor: 2) ).
			Transcript show: outString;cr.
			P2Client sendData: outString.
		].
	]."

	(P2Client dataAvailable) ifTrue:
	[
		P2Client receiveDataInto: P2Buf.
		(P1Client = nil )
		ifFalse: [
			self handleUpdate: P2Buf from: 2.
			player2State := P2Buf.
			outString := ( '|', (self getPlayerFromUpdate: player2State from: 2),bulletString at: 1,bulletString at: 2 ).
			P1Client sendData: outString.
		]
		ifTrue:[
			self color: Color red.
		].
	].
	"ifFalse:[
		(forceRun) ifTrue:[
			
			outString := ( '|', (self getPlayerFromUpdate: player2State from: 2),((bulletList at: 1) serializePosFor: 1),((bulletList at:2) serializePosFor: 1) ).
			P1Client sendData: outString.
		].
	].
"! !

!Server methodsFor: 'run' stamp: 'JonathanMark 7/27/2014 23:22'!
stepTime
^33! !

!Server methodsFor: 'run' stamp: 'JonathanMark 7/30/2014 23:30'!
updateBullets
	|  bullet |
	
	((bulletList at: 1) isAlive) ifTrue: [ 
			bullet := (bulletList at: 1).
			(bulletList at: 1) stepManual.
			(self checkCollision: ((playerXList at: 2) - Tank width) bullet:1) 
				ifTrue: [ playerHealthList at: 2 put: ((playerHealthList at: 2) - ((bulletList at: 1) getStrength)). ]. 
			((bulletList at: 1) isAlive) ifTrue: [ 
				( (bullet position y + 20) > (level at: ((bullet position x) + (Bullet width / 2) asInteger )) ) ifTrue: [ (bulletList at: 1) kill ].
			].

	].
	((bulletList at: 2) isAlive) ifTrue: [ 
			(bulletList at: 2) stepManual.
			bullet := (bulletList at: 2).
			(self checkCollision: (playerXList at: 1) bullet:2) ifTrue: [ playerHealthList at: 1 put: ((playerHealthList at: 1) - ((bulletList at: 2) getStrength)) ].
			((bulletList at: 2) isAlive) ifTrue: [ 
				((bullet position y + 20) > (level at: ((bullet position x) + (Bullet width /2) asInteger )) ) ifTrue: [ (bulletList at: 2) kill ].
			].
			 
	].

	! !

!Server methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/26/2014 12:51'!
updateClient1Data: aString
	"take the string sent by the client and update it to send back to the client 2"
	| tokens player bullet playerTokens bulletTokens|
	
	tokens := aString subStrings: ';'.
	tokens size > 1 ifTrue: [ 
	player := (tokens at: 1).
	bullet := (tokens at: 2).
	playerTokens := player subStrings: ':'.
	bulletTokens := bullet subStrings: ':'.
			bulletTokens size < 7 ifTrue: [ 
			^'10:10:0:1:1:0'.
		 ].
	((playerTokens at: 1) beginsWith: 'ack') ifFalse: [ 
	client1Data := ((1200 - playerTokens at: 1 asNumber) asString, ':', (playerTokens at: 2), ':', (playerTokens at: 3), ';', (1200 - (bulletTokens at: 1 asNumber)) asString, ':',
			(bulletTokens at: 2), ':', (bulletTokens at: 3), ':', (bulletTokens at: 4), ':', (-1 * ((bulletTokens at: 5) asNumber)) asString,
			':', (bulletTokens at: 6), ':', (bulletTokens at: 7), ':', (bulletTokens at: 8), ':', (bulletTokens at: 9), ':', (bulletTokens at: 10),
			':', (bulletTokens at: 11)).
	].
	].! !

!Server methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/26/2014 12:57'!
updateClient2Data: aString
	"take the string sent by the client and update it to send back to the client 2"
	| tokens player bullet playerTokens bulletTokens|
	"Transcript show: aString; cr.	"
	tokens := aString subStrings: ';'.
	tokens size > 1 ifTrue: [ 
	player := (tokens at: 1).
	bullet := (tokens at: 2).
	playerTokens := player subStrings: ':'.
	bulletTokens := bullet subStrings: ':'.
			bulletTokens size < 7 ifTrue: [ 
			^'10:10:0:1:1:0'.
		 ].
	((playerTokens at: 1) beginsWith: 'ack') ifFalse: [ 
	client2Data := ((1200 - playerTokens at: 1 asNumber) asString, ':', (playerTokens at: 2), ':', (playerTokens at: 3), ';', (1200 - (bulletTokens at: 1 asNumber)) asString, ':',
			(bulletTokens at: 2), ':', (bulletTokens at: 3), ':', (bulletTokens at: 4), ':', (-1 * ((bulletTokens at: 5) asNumber)) asString,
			':', (bulletTokens at: 6), ':', (bulletTokens at: 7), ':', (bulletTokens at: 8), ':', (bulletTokens at: 9), ':', (bulletTokens at: 10),
			':', (bulletTokens at: 11)).
	].
	].! !

Morph subclass: #Tank
	instanceVariableNames: 'positionX positionY angle power'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!Tank class methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/28/2014 22:22'!
height
	^30! !

!Tank class methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/28/2014 22:23'!
width
	^50! !

!Tank methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/19/2014 12:50'!
"protocol: as yet unclassified"
drawOn: aCanvas
	| turretStart turretEndX turretEndY |

	aCanvas fillRectangle: bounds color: color.
	turretStart := (bounds center).
	
	turretEndX := turretStart x + (20 * (angle degreesToRadians cos)).
	turretEndY := turretStart y - (20 * (angle degreesToRadians sin)).
	
	aCanvas line: turretStart to: (turretEndX@turretEndY) width: 3 color: Color black.! !

!Tank methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 17:57'!
getAngle
	^angle
	! !

!Tank methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 17:57'!
getPower
	^power
	! !

!Tank methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 17:56'!
getX
	^positionX
	! !

!Tank methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 17:57'!
getY
	^positionY
	! !

!Tank methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/19/2014 12:28'!
incAngle: anAmount
 angle := angle + anAmount.! !

!Tank methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/28/2014 22:23'!
initialize
	super initialize.
	self color: Color blue.
	self bounds: (0@0 extent: 50@30).
	
	positionX := 0.
	positionY := 0.
	angle := 45.
	power := 50.
	! !

!Tank methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 18:08'!
setAngle: thisAngle
 angle := thisAngle rounded.! !

!Tank methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 17:53'!
setPower: thisPower
 power := thisPower.! !

!Tank methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 17:48'!
setX:x setY:y
	positionX := x.
	positionY := y.
	
	self position: (x@y).
	! !

TextMorph subclass: #HUD
	instanceVariableNames: 'font string value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!HUD methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/25/2014 22:43'!
setFont:fonta setString:str setValue:val setX:xVal setY:yVal
 font := fonta.
 string := str.
 value := val.

self contents: ((string,value asString) asText addAttribute: font).
self position: (xVal@yVal).! !

!HUD methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/25/2014 22:39'!
setValue:val
 value := val.
 
self contents: ((string,value asString) asText addAttribute: font).! !

IconicButton subclass: #HUDbutton
	instanceVariableNames: 'event'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!HUDbutton methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/25/2014 22:39'!
mouseDown: anEvent

anEvent redButtonPressed
 ifTrue: event.
^ super mouseDown: anEvent.! !

!HUDbutton methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/25/2014 22:40'!
setLabel: labela setHeight: height setWidth: width setX: xVal setY: yVal gameBoard: gb
 
 super initialize.

 self label: labela.
 self height: height.
 self width: width.
 self position: (xVal@yVal).
 
event := gb.! !

Object subclass: #Client
	instanceVariableNames: 'socket playerX initString game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!Client commentStamp: '<historical>' prior: 0!
A Client is the TCP client of the game.
!

!Client methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/21/2014 23:08'!
getInitString
	^initString.! !

!Client methodsFor: 'as yet unclassified' stamp: 'CaseyPiper 7/25/2014 01:12'!
getPlayer1Bullet
	"return a string with the information about player 1"
	^game getPlayerOne getBullet serialize.! !

!Client methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/26/2014 12:46'!
getPlayer1Information
	"return a string with the information about player 1"
	"Return the x position of the tank"
	| infoString |
	infoString := (((game getPlayerOne getX) asInteger asString), ':', game getPlayerTwo getHealth asString, ':', ((game getPlayerOne getTank getAngle) asInteger asString)).
	"infoString := infoString, ','."
	^infoString.! !

!Client methodsFor: 'as yet unclassified' stamp: 'CaseyPiper 7/18/2014 00:55'!
getPlayerX
	^playerX! !

!Client methodsFor: 'initialization' stamp: 'JonathanMark 7/21/2014 23:08'!
initialize
   Smalltalk garbageCollect.
   playerX := 0.
   initString := nil.! !

!Client methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/21/2014 23:05'!
parseServerInitialization: aString
	"take the string passed from the server, and initialize the game board."
	initString := aString.! !

!Client methodsFor: 'instructions' stamp: 'JonathanMark 8/2/2014 00:12'!
receive
| serverUpdate output |
	
	output := ''.

	( socket dataAvailable ) ifTrue:
	[
		 [ socket dataAvailable ] whileTrue: [
				serverUpdate := String new: 200.
				socket receiveDataInto: serverUpdate.
				output := output,serverUpdate.
		].
		^output.
	]
	ifFalse: [ ^nil ]! !

!Client methodsFor: 'instructions' stamp: 'JonathanMark 7/27/2014 22:23'!
send: aByteArray
	socket sendData: aByteArray.

! !

!Client methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/24/2014 22:46'!
setGame: aGame
	game := aGame.! !

!Client methodsFor: 'as yet unclassified' stamp: 'CaseyPiper 7/18/2014 00:45'!
setPlayerX: aLocation
	playerX := aLocation.! !

!Client methodsFor: 'initialization' stamp: 'JonathanMark 8/1/2014 23:44'!
start: port
    | receiveBuf temp timeout delay |

Smalltalk garbageCollect.

Transcript show: 'starting client'; cr.
Transcript show: 'initializing network ... '.
Transcript show: 'ok'; cr.

socket := Socket newTCP.
socket connectTo: (NetNameResolver addressForName: '25.61.19.54') port: port.
      
socket waitForConnectionFor: 10.
Transcript show: 'client endpoint created'; cr.
temp := nil.
timeout := 0.

[ socket isConnected and: [ temp = nil or: [timeout < 10]] ] whileTrue: [ 
	socket dataAvailable ifTrue: [ 
		temp := String new: 1000.
		socket receiveDataInto: temp.
		self parseServerInitialization: temp.
		
	].
	timeout := timeout + 1.
	delay := Delay forMilliseconds: 500.
	delay wait.
].

! !

!Client methodsFor: 'as yet unclassified' stamp: 'CaseyPiper 7/22/2014 23:25'!
startPlayer1Client: aPlayer

Smalltalk garbageCollect.

Transcript show: 'starting client'; cr.
Transcript show: 'initializing network ... '.
Transcript show: 'ok'; cr.

socket := Socket newTCP.
socket connectTo: (NetNameResolver addressForName: 'localhost') port: 12345.
[
	| temp |
      socket waitForConnectionFor: 10.
      Transcript show: 'client endpoint created'; cr.
	temp := nil.

	[ socket isConnected ] whileTrue: [ 
	"Transcript show: 'this'; cr."
		socket dataAvailable ifTrue: [ 
			temp := String new: 1000.
			socket receiveDataInto: temp.
			Transcript show: 'server sent:'; show: temp; cr.

				Transcript show: 'sending' ; cr.
				self send: aPlayer getX asString. 
				temp := nil.


			
		]
	].
"

	temp := nil.

	[ socket isConnected and: [ temp = nil ] ] whileTrue: [ 
		socket dataAvailable ifTrue: [ 
			temp := String new: 1000.
			socket receiveDataInto: temp.
			self parseServerInitialization: temp.
			
		]
	].
	
	[socket isConnected] whileTrue: [ 
			socket dataAvailable ifTrue: [ 
					receiveBuf := String new: 1000.
					socket receiveDataInto: receiveBuf.
					receiveBuf asNumber = 0 ifFalse: [ 
						self setPlayerX: (receiveBuf asNumber).
					].
					Transcript cr; show: 'Received something';cr.
				 ].
		 ].
"
	Transcript show: 'remoteClient TCP test done;' ; cr.

] forkAt: Processor userBackgroundPriority.! !

!Client methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/19/2014 12:35'!
updateData: aPlayer
	| bytesSent aByteArray |
	aByteArray := aPlayer getX asString.
[
	socket isNil ifFalse: [ 
	bytesSent := socket sendData: aByteArray.
	bytesSent <= 0 ifTrue: [ Transcript show: 'no data sent'; cr. 
			socket closeAndDestroy.
		]
	]
] forkAt: Processor userBackgroundPriority.! !

!Client methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/26/2014 13:06'!
updateGameWithServerInfo: aString
	"take string from server and update player 2 with it"
|token playerToken bulletToken updatedX subPlayer newHealth turrAngle |
(aString at: 1) = $p ifFalse: [ 
	"Transcript show: ('updating game with ', aString); cr."
	token := aString subStrings: ';'.
	token size > 1 ifTrue: [ 
		playerToken := (token at: 1).
		subPlayer := playerToken subStrings: ':'.
		updatedX := (subPlayer at: 1) asInteger.
		newHealth := (subPlayer at: 2) asInteger.
		(newHealth = nil) ifFalse:[ game getPlayerOne setHealth: newHealth].
		"Transcript show: 'updating player with X value '; show: updatedX; cr.	"
		(updatedX = nil) ifFalse:[ game player2Update: updatedX].
		turrAngle := (subPlayer at: 3) asInteger.
		(turrAngle = nil) ifFalse:[ game getPlayerTwo getTank setAngle: (turrAngle negated + 180) ].
		"bulletToken := (token at: 2)."
		bulletToken := (token at: 2).
		game getPlayerTwo getBullet deserialize: bulletToken.
		game addMorph: (game getPlayerTwo getBullet).
	].
].
	! !

Object subclass: #Player
	instanceVariableNames: 'bullet tank health shell'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!Player methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 17:49'!
getBullet
	^bullet! !

!Player methodsFor: 'as yet unclassified' stamp: 'GKB 7/24/2014 23:25'!
getHealth
	^health! !

!Player methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/19/2014 11:20'!
getShell
	^shell! !

!Player methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 17:49'!
getTank
	^tank! !

!Player methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/19/2014 12:13'!
getX
	| initialDegrees xVal |
	initialDegrees := shell rotationDegrees.
	shell rotationDegrees: 0.
	xVal := shell position x.
	shell rotationDegrees: initialDegrees.
	^xVal.! !

!Player methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/19/2014 12:25'!
getY
	| initialDegrees yVal |
	initialDegrees := shell rotationDegrees.
	shell rotationDegrees: 0.
	yVal := shell position y.
	shell rotationDegrees: initialDegrees.
	^yVal.! !

!Player methodsFor: 'as yet unclassified' stamp: 'GKB 7/17/2014 17:44'!
isAlive
	(health > 0)
		ifTrue: [ ^true ]
		ifFalse: [ ^false ].! !

!Player methodsFor: 'as yet unclassified' stamp: 'GKB 7/24/2014 23:25'!
setHealth: newHealth
	health := newHealth. ! !

!Player methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/19/2014 12:04'!
setShell
	shell := tank addFlexShell.! !

!Player methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/19/2014 11:17'!
xMin:xMn xMax:xMx yMax:yMx tankX:tX tankY: tY
	
	health := 100.
	tank := Tank new setX: tX setY: tY.
	bullet := Bullet new xMin:xMn xMax:xMx yMax:yMx.
! !

Array variableSubclass: #Level
	instanceVariableNames: 'levelVar1 levelVar2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tank Game'!

!Level methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/24/2014 23:48'!
slopeFrom: x1 to: x2 
	| subArray min slope |
	
	subArray := self copyFrom: x1 to: x2.
	
	min := subArray inject: (720) into: [:a :c | (a < c)
									ifTrue: [a]
  							 		ifFalse: [c]].
	
	slope := ((self at: x2) - (self at: x1)) asFloat / (x2 - x1).
	
	^slope
! !

!Level methodsFor: 'as yet unclassified' stamp: 'JonathanMark 7/25/2014 19:23'!
var1: aVar1 var2: aVar2 var3: aVar3 dir: dirVar
	| xCord |
	1 to: self size do: [  :x |
		(dirVar asInteger = 1) 
			ifTrue: [ xCord := x ]
			ifFalse: [ xCord := self size - x + 1].
		self at: xCord put: (((aVar1/1000*x) + aVar3) sin) * aVar2 + 240.
	].! !
